'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isFeatureEnabled = isFeatureEnabled;

var _reactRedux = require('react-redux');

var _const = require('./const');

function Feature(_ref) {
  var isEnabled = _ref.isEnabled,
      children = _ref.children;

  if (isEnabled) {
    return children;
  }

  return null;
}

function isFeatureEnabled(features, featureName) {
  return features[featureName];
}

function mapStateToProps(state, _ref2) {
  var name = _ref2.name;

  var features = state[_const.STORE_KEY];
  return {
    isEnabled: isFeatureEnabled(features, name)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps)(Feature);