'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _const = require('./const');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var isImmutable = function isImmutable(s) {
  return Boolean(s.toJS);
};

var createRefinedState = function createRefinedState() {
  var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var flags = arguments[1];

  if (isImmutable(state)) {
    return state.set(_const.STORE_KEY, flags);
  }

  return _extends({}, state, _defineProperty({}, _const.STORE_KEY, flags));
};

var getFlagsInternal = function getFlagsInternal(state) {
  if (isImmutable(state)) {
    return state.get(_const.STORE_KEY, {});
  }

  return state[_const.STORE_KEY] || {};
};

var setFlagsInternal = function setFlagsInternal(state, action) {
  var _getFlagsInternal = getFlagsInternal(state),
      flags = _getFlagsInternal.flags;

  var member = _extends({}, flags, action.payload);

  if (isImmutable(state)) {
    return state.update(_const.STORE_KEY, function (obj) {
      return _extends({}, obj, member);
    });
  }

  return _extends({}, state, _defineProperty({}, _const.STORE_KEY, _extends({}, state[_const.STORE_KEY], member)));
};

exports.default = function (initFeatures) {
  return function (createStore) {
    return function (reducer, initState, enhancer) {
      var refinedReducer = function refinedReducer(state, action) {
        if (action.type === '@@FEATURE_FLAG/SET') {
          return setFlagsInternal(state, action);
        }

        return reducer(state, action);
      };

      var refinedInitialState = createRefinedState(initState, initFeatures);

      return createStore(refinedReducer, refinedInitialState, enhancer);
    };
  };
};